/**
	* Efficiency: the closetag also needs to match.  At the moment,
	* the hack is to also map the closetag - but it would be more efficient
	* to instead save the first mapping.  OTOH, hashing is very quick, and
	* JSX efficiency is dominated by other factors than this - so not worth
	* worrying about.  
	*
	* Potential problem: not all Class.forName() calls are mapped through
	* resolveClass(), and so the mappings won't be active there.
	**/


package JSX;
import java.util.Map;
public class ClassRefactor implements Refactor {
	Map map;
	public ClassRefactor(Map map) {	//takes a HashMap, HashTable etc
		this.map = map;
			//check for correct types: String, String
			//check for no many:1
			//Alt: load up from an array (of String[][]?  or two String[]?)
	}
	public String mapClassname(String packageQualifiedClassname) {
		String newClassname = (String) map.get(packageQualifiedClassname);
		if (newClassname==null)
			return packageQualifiedClassname;
		else
			return newClassname;
	}
}
