package JSX;
import java.util.Map;
import java.util.List;
import java.util.Iterator;
public class PackageRefactor implements Refactor {
	Map map;
	public PackageRefactor(Map map) {	//takes a HashMap, HashTable etc
		this.map = map;
			// check for correct types:
			//   String, String
			//   String, List <---- for safe auto-discovery
			//check that there is no merging (possible clash) "not many:1"
			//Alt: load up from an array (of String[][]?  or two String[]?)
	}
	public String mapClassname(String packageQualifiedClassname) {
		String initialPackage = packageQualifiedClassname.substring(0, packageQualifiedClassname.lastIndexOf('.')); // extract package name
		String initialClassname = packageQualifiedClassname.substring(packageQualifiedClassname.lastIndexOf('.')+1);

		Object packageOrList = map.get(initialPackage);  // map to new one
		if (packageOrList==null)
			return packageQualifiedClassname;	// leave as is
		else if (packageOrList instanceof String)
			return ((String) packageOrList)+"."+initialClassname;  // create new one
		else if (packageOrList instanceof List) {	//search through list
			boolean found = false;
			String newFullName = null;
			for (Iterator i = ((List)packageOrList).iterator(); i.hasNext(); ) {
				newFullName = ((String)i.next())+"."+initialClassname; 
				Class clazz;
				try {
					clazz=Thread.currentThread().getContextClassLoader().loadClass(newFullName); // we could factor this out
					found = true;
					break;	// success!  Now end the search
				} catch (ClassNotFoundException ignored) {}
			}
			if (found)
				return newFullName;
			else
				return null;	// auto-discovery failed - throw ClassNotFoundException?
		}
		else
			throw new Error("Value corresponding to "+ initialPackage +" is "+ packageOrList.getClass() + " but should be List, String or null");
	}
}
