package JSX;
import java.io.StringWriter;
import java.io.IOException;


public class Util {
/** If you really wanted to test this out more extensively, you could
	* get the initial objects from XML, by reading in from two separate files.
	* Then you could edit the files by hand, to check to see if it
	* picked up the differences.  Clearly it should work, but (eg) you would
	* find that non-significant aspects (eg indentation) made no difference.
	**/
	public static void main(String[] args) throws IOException {	//a test case
		Object[] leaf = {"left-leaf", "right-leaf"};
		Object[] branch = {leaf, "middle-leaf", leaf};
		Object[] root = {null, "another one", branch, leaf};
		root[0] = root;

		Object[] leaf1 = {"left-leaf", "right-leaf"};
		Object[] branch1 = {leaf1, "middle-leaf", leaf1};
		Object[] root1 = {null, "another one", branch1, leaf1};
		root1[0] = root1;

		new ObjOut().writeObject(root);		//just to have a look
		new ObjOut().writeObject(root1);		//just to have a look

		System.out.print("Are they equal?  "+equals(root, root1));
	}

	public static boolean equals(Object obj1, Object obj2) {
		String a = getString(obj1);
		String b = getString(obj2);
		return a.equals(b);
	}
	private static String getString(Object obj) {
		try {
			StringWriter sout = new StringWriter();
			ObjOut out = new ObjOut(sout);
			out.writeObject(obj);
			return sout.toString();
		} catch (IOException stringProblem) {
			stringProblem.printStackTrace();	//could ever happen? Memory insuff?
			return null;
		}
	}
	private Util() {}	//so can't be instantiated
}
