var CARD_TEMPLATE =
	"<div id=\'card-{{ID}}\' class=\'history-entry\'> \n" + 
	"	<div class=\'history-entry-content\'> \n" + 
	"		<div style=\'font-size: small;\'>{{DATE}}:</div> \n" + 
	"		<span id=\'text-{{ID}}\'>{{TEXT}}</span> \n" + 
	"	</div> \n" + 
	"	<div class=\'history-entry-state\'> \n" + 
	"		<div class=\'state state-sent\' id=\'state-{{ID}}\'></div> \n" + 
	"	</div> \n" + 
	"	<div style=\'clear: both;\'></div> \n" + 
	"</div>";

_Y.use("node", "datatype-date", function(Y) {
	
	Card = function(type, text, topicId) {
		this.id = new UUID();
		this.date = new Date();
		this.type = type;
		this.text = text;
		this.state = 'sent';
		
		var html = CARD_TEMPLATE.replace(/{{TEXT}}/g, this.text);
		html = html.replace(/{{ID}}/g, this.id);
		html = html.replace(/{{DATE}}/g, Y.DataType.Date.format(this.date, { format: "%x %X" }));
		
		this.node = Y.Node.create(html);
	};
	
	Card.prototype = {
		id: null,
		date: null,
		type: null,
		text: null,
		topicId: null,
		node: null,
		state: null,
		
		getId: function() { return this.id; },
		getType: function() { return this.type; },
		getText: function() { return this.text; },
		getHistoryHtmlElement: function() { return this.node; },
		
		setState: function(s) {
			Y.one("#state-" + this.id).removeClass('state-' + this.state);
			Y.one("#state-" + this.id).addClass('state-' + s);
			this.state = s;
		}
	};
	
});
