_Y.use("gallery-accordion", "console", "node", "io-base", function(Y) {
	
	/**
	 * TopicController Klasse
	 */
	TopicController = function() {
		this.accordion = new Y.Accordion({
        	srcNode: "#brainstormings-accordion",
        	useAnimation: true,
        	collapseOthersOnExpand: true        	            	
    	});
		this.accordion.on("itemExpanded", this.onAccordionItemExpandend, this);
		this.accordion.render();
	};
	
	TopicController.prototype = {
		topics: [],
		accordion: null,
		
		createTopicNode: function(data) {
			var topic = new Topic(data);
			this.accordion.addItem(topic.getItem());
			topic.initListeners();
			return topic;
		},
	
		onAccordionItemExpandend: function(e) {
			var topic = this.findTopicForAccordionItem(e.item);
			if (topic == null) {
				return;
			}
			topic.focus();
		},
	
		findTopicForAccordionItem: function(item) {
			for (var i = 0; i < this.topics.length; i++) {
				if (this.topics[i].getItem() == item) {
					return this.topics[i];
				}
			}
			return null;
		},
	
		update: function(data) {
			var newTopics = [];
			var foundActiveTopic = false;
			var created = false;
			var changed = false;
			var found = 0;
			for (var i = 0; i < data.length; i++) {
				var topic = this.findTopic(data[i].id);
				if (topic == null) {
					topic = this.createTopicNode(data[i]);
					created = true;
				} else {
					topic.update(data[i]);
					found++;
				}
				newTopics[newTopics.length] = topic;
			}
			
			var oldTopics = this.topics;
			this.topics = newTopics;
			
			if (found != oldTopics.length) {
				// delete 
				for (var i = 0; i < oldTopics.length; i++) {
					var topic = oldTopics[i];
					if (this.findTopic(topic.getData().id) == null) {
						this.accordion.removeItem(topic.getItem());
					}
				}
			}
			
		},
		
		findTopic: function(id) {
			for (var i = 0; i < this.topics.length; i++) {
				if (this.topics[i].getId() == id) {
					return this.topics[i];
				}
			}
			return null;
		}
	};
});
